TACHYON

: START   CNT@ >L ;
: LAP	   CNT@ L> - #80,000 / ;

: SCL	28d MASK ;
: SDA	29d MASK ;
: SDA?	29d IN ;


: IICST	SDA INPUTS SCL OUTSET SDA OUTCLR SCL OUTCLR ;
: IICSP	SDA OUTCLR SCL OUTSET SDA INPUTS ;

{ This routine runs at an I2C speed of 125kHz }
: IIC!	 ( data -- flg ) \ write a byte to the I2C bus and return with the ack (0=ack)	
		#24 REV SCL SWAP SDA DUP OUTSET SWAP 8
		FOR 
		  OVER OUT   
		  3RD OUTSET 3RD OUTCLR   
		  NEXT 
		DROP INPUTS		( float SDA )
		DUP OUTSET SDA? SWAP OUTCLR ( ack clock )
		;

\ CLKDAT ( sdat scnt -- data )  ( L: miso mosi sck )

{   this version needs CLKDAT to slow down about 7 times to work down to 400kHz
: IIC!	 ( data -- flg ) \ write a byte to the I2C bus and return with the ack (0=ack)	
		0 >L SDA >L SCL >L 
		24d REV 
		SCL OUTSET SDA OUTSET  
		8 CLKDAT SDA INPUTS
		DROP SCL OUTSET SDA? SCL OUTCLR
		L> DROP L> L> 2DROP
		;
}
: IIC@	( ack -- data )	
		SDA INPUTS SCL 0  ( ack sck dat )
		8 FOR OVER OUTSET 2* SDA? - OVER OUTCLR NEXT 
		ROT 0= IF SDA OUTCLR THEN OVER OUTSET SWAP OUTCLR SDA INPUTS
		  ;
: @EE ( addr -- flg )		
	IICST $A0 IIC! OVER 8 SHR IIC! OR SWAP IIC! OR 
	;
: EERD ( -- flg  )		
	IICST $A1 IIC!  
	;
: ENDRD	1 IIC@ IICSP ;

: EDUMP ( addr cnt -- )
	IICSP OVER @EE EERD OR
	IF 2DROP ." BAD RESPONSE FROM EEPROM "
	ELSE
	ADO I $0F AND 0= IF CR I .WORD ." : " THEN
	  0 IIC@ .BYTE BL EMIT 
	  LOOP
	ENDRD DROP	
	THEN   
	;	  

	 
: EE!		( byte addr -- ) @EE SWAP IIC! OR IICSP ;
: EE@		( addr -- byte ) @EE SWAP EERD DROP ENDRD ;

: ESAVE ( ram eeprom cnt -- )
	ROT SWAP ADO 
	  BEGIN DUP @EE 0= UNTIL
	  0 I $40 ADO I C@ IIC! OR LOOP IICSP IF $0D EMIT ." FAIL @" I .WORD THEN
	  SPINNER
	  $40 + $40 
	+LOOP DROP
	;

\ 5.879sec for 32K  - now 4.325sec

: ELOAD ( eeprom ram cnt -- )
	ROT BEGIN @EE 0= UNTIL EERD DROP
	ADO 0 IIC@ I C! LOOP
	ENDRD DROP 
;

END


